package cn.com.tenlion.systembase.service.logisticssafe;

import cn.com.tenlion.systembase.pojo.bos.logisticssafe.LogisticsSafeBO;
import cn.com.tenlion.systembase.pojo.dtos.logisticssafe.LogisticsSafeDTO;
import cn.com.tenlion.systembase.pojo.pos.logisticssafe.LogisticsSafePO;
import cn.com.tenlion.systembase.pojo.vos.logisticssafe.LogisticsSafeVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ILogisticsSafeService
 * @Description: 寄递物流安全管理
 * @Author: CodeFactory
 * @Date: 2021-10-19 14:16:33
 * @Version: 3.0
 **/
public interface ILogisticsSafeService {

    /**
     * 新增寄递物流安全管理
     *
     * @param logisticsSafeVO
     * @return
     */
    void save(LogisticsSafeVO logisticsSafeVO);

    /**
     * 新增寄递物流安全管理
     *
     * @param token
     * @param logisticsSafeVO
     * @return
     */
    void save(String token, LogisticsSafeVO logisticsSafeVO);

    /**
     * 新增寄递物流安全管理
     *
     * @param logisticsSafeVO
     * @return logisticsSafeId
     */
    String saveReturnId(LogisticsSafeVO logisticsSafeVO);

    /**
     * 新增寄递物流安全管理
     *
     * @param token
     * @param logisticsSafeVO
     * @return logisticsSafeId
     */
    String saveReturnId(String token, LogisticsSafeVO logisticsSafeVO);

    /**
     * 删除寄递物流安全管理
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除寄递物流安全管理
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除寄递物流安全管理（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改寄递物流安全管理
     *
     * @param logisticsSafeId
     * @param logisticsSafeVO
     * @return
     */
    void update(String logisticsSafeId, LogisticsSafeVO logisticsSafeVO);

    /**
     * 修改寄递物流安全管理
     *
     * @param token
     * @param logisticsSafeId
     * @param logisticsSafeVO
     * @return
     */
    void update(String token, String logisticsSafeId, LogisticsSafeVO logisticsSafeVO);

    /**
     * 寄递物流安全管理详情
     *
     * @param params 参数Map
     * @return
     */
    LogisticsSafeDTO get(Map<String, Object> params);

    /**
     * 寄递物流安全管理详情
     *
     * @param logisticsSafeId
     * @return
     */
    LogisticsSafeDTO get(String logisticsSafeId);

    /**
     * 寄递物流安全管理详情
     *
     * @param params 参数Map
     * @return
     */
    LogisticsSafeBO getBO(Map<String, Object> params);

    /**
     * 寄递物流安全管理详情
     *
     * @param logisticsSafeId
     * @return
     */
    LogisticsSafeBO getBO(String logisticsSafeId);

    /**
     * 寄递物流安全管理详情
     *
     * @param params 参数Map
     * @return
     */
    LogisticsSafePO getPO(Map<String, Object> params);

    /**
     * 寄递物流安全管理详情
     *
     * @param logisticsSafeId
     * @return
     */
    LogisticsSafePO getPO(String logisticsSafeId);

    /**
     * 寄递物流安全管理列表
     *
     * @param params
     * @return
     */
    List<LogisticsSafeDTO> list(Map<String, Object> params);

    /**
     * 寄递物流安全管理列表
     *
     * @param params
     * @return
     */
    List<LogisticsSafeBO> listBO(Map<String, Object> params);

    /**
     * 寄递物流安全管理列表
     *
     * @param params
     * @return
     */
    List<LogisticsSafePO> listPO(Map<String, Object> params);

    /**
     * 寄递物流安全管理分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<LogisticsSafeDTO>> listPage(ListPage page);

    /**
     * 寄递物流安全管理统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}